float4x4 tW: WORLD;        //the models world matrix
float4x4 tV: VIEW;         //view matrix as set via Renderer (DX9)
float4x4 tP: PROJECTION;   //projection matrix as set via Renderer (DX9)
float4x4 tWVP: WORLDVIEWPROJECTION;



texture Tex <string uiname="Texture B&W";>;
float4x4 tTex <string uiname="Texture Transform B&W";>;                  //Texture Transform
sampler ImageSamplerMask = sampler_state    //sampler for doing the texture-lookup
{
    Texture   = (Tex);          //apply a texture to the sampler
    MipFilter = LINEAR;         //set the sampler states
    MinFilter = LINEAR;
    MagFilter = LINEAR;

};



texture ImageTexture
<string uiname="Texture";>;
float4x4 tTex1 <string uiname="Texture Transform";>;
sampler2D ImageSampler1 = sampler_state
{
    Texture = <ImageTexture>;
    MinFilter = LINEAR;
    MagFilter = LINEAR;
    MipFilter = None;


};

texture ImageTextureBack
<string uiname="Texture Background";>;
float4x4 tTex2 <string uiname="Texture Background Transform";>;
sampler2D ImageSampler2 = sampler_state
{
    Texture = <ImageTextureBack>;
    MinFilter = LINEAR;
    MagFilter = LINEAR;
    MipFilter = None;
    AddressU = CLAMP;
    AddressV = CLAMP;

};

///////////////////////////////////////vertexshader///////////////////////

float Tresh <String uiname="Tresh"; float uimin=0.0;> = 1;
float Alpha;
struct VS_OUTPUT
{
    float4 Pos  : POSITION;
    float4 TexC : TEXCOORD0;
    float4 TexC1 : TEXCOORD1;
    float4 TexC2 : TEXCOORD2;
};

VS_OUTPUT VS(
    float4 Pos  : POSITION,
    float4 TexC : TEXCOORD,
    float4 TexC1 : TEXCOORD1,
    float4 TexC2 : TEXCOORD2)
{
    //inititalize all fields of output struct with 0
    VS_OUTPUT Out = (VS_OUTPUT)0;

    //transform position
    Pos = mul(Pos, tWVP);
    //transform texturecoordinates
    Out.TexC1 =mul(TexC, tTex1);
    TexC = mul(TexC, tTex);

    Out.Pos  = Pos;
    Out.TexC = TexC;
    Out.TexC2 = TexC2;

    return Out;
}

////////////////////////////////pixelshader////////////////////////////////////

float4 dispPS(float4 TexC: TEXCOORD0,float4 TexC1: TEXCOORD1,float4 TexC2: TEXCOORD2) : COLOR
{
	float disp = ( ( (float4)tex2D(ImageSamplerMask, TexC) ) );
	float4 texCol = tex2D(ImageSampler1,TexC1);
	float4 texCol2 = tex2D(ImageSampler2,TexC1);


        texCol = texCol2;
        texCol.a=disp*Alpha;
        return texCol;


}
/////////////////////////////////technique////////////////////////////////////

technique BlendByTexture {
	pass TexturePass  {
		VertexShader = compile vs_2_0 VS();

		PixelShader  = compile ps_2_a dispPS();
	}
}

/***************************** eof ***/
